\input{../../include/schemes-reference}
\input{../../include/schemes}
\begin{document}
\begin{tikzpicture}[
    axis/.style = {draw = black, line width = \submatrixlinewidth},
    submatrix/.style = {draw = black, line width = \submatrixlinewidth},
    submatrixlabel/.style = {
      draw = black, fill = white, anchor = center, align = center,
      scale = \labelscale, inner sep = \labelinnersep,
      line width = \labellinewidth
    }
  ]
  % Top green and red lines.
  \draw[
    draw = green, line width = \sidelinewidth
  ] (-1.55 * \drawscale, 1.7 * \drawscale) node{}
  -- (0.45 * \drawscale, 1.7 * \drawscale);
  \draw[
    draw = red, line width = \sidelinewidth
  ] (0.55 * \drawscale, 1.7 * \drawscale) node{}
  -- (1.55 * \drawscale, 1.7 * \drawscale);
  % Left green and red lines.
  \draw[
    draw = green, line width = \sidelinewidth
  ] (-1.7 * \drawscale, 1.55 * \drawscale) node{}
  -- (-1.7 * \drawscale, -0.45 * \drawscale);
  \draw[
    draw = red, line width = \sidelinewidth
  ] (-1.7 * \drawscale, -0.55 * \drawscale) node{}
  -- (-1.7 * \drawscale, -1.55 * \drawscale);
  % Blocks
  \draw[draw = repetition, line width = 2 * \sidelinewidth]
  (-1.55 * \drawscale, 1.55 * \drawscale) rectangle
  ++(2 * \drawscale, -2 * \drawscale);
  \draw[draw = repetition, line width = 2 * \sidelinewidth]
  (-1.55 * \drawscale, -1.05 * \drawscale) rectangle
  ++(2 * \drawscale, -0.5 * \drawscale);
  \draw[draw = repetition, line width = 2 * \sidelinewidth]
  (1.05 * \drawscale, -0.45 * \drawscale) rectangle
  ++(-0.5 * \drawscale, 2 * \drawscale);
  % Axes
  \draw[|-{latex[length=4mm]}, axis]
  (-1.8 * \drawscale, -0.55 * \drawscale) node[
    anchor = east
  ] {\Large $1$}
  -- (-1.8 * \drawscale, -1.3 * \drawscale) node[
    anchor = east
  ] {\Large $\mathbf{i}$}
  -- (-1.8 * \drawscale, -1.55 * \drawscale) node[
    anchor = east
  ] {\Large $n_b$};
  \draw[|-{latex[length=4mm]}, axis]
  (0.55 * \drawscale, 1.8 * \drawscale) node[
    anchor = south
  ] {\Large $1$}
  -- (0.8 * \drawscale, 1.8 * \drawscale) node[
    anchor = south
  ] {\Large $\mathbf{j}$}
  -- (1.55 * \drawscale, 1.8 * \drawscale) node[
    anchor = south
  ] {\Large $n_b$};
  % Sparse/dense matrix.
  \node[
    matrix, draw = black, line width = \matrixlinewidth,
    inner sep = \matrixinnersep
  ] (FB) at (0, 0) {
    \draw[
      submatrix, pattern = fillin, pattern color = green
    ] (0, 0) node[anchor = west]{}
    -- (2 * \drawscale, 0) node[anchor = north]{}
    -- (0, 2 * \drawscale) node[anchor = north west]{}
    -- cycle;
    \draw[
      submatrix, pattern = fillin, pattern color = green
    ] (2 * \drawscale, 0) node[anchor = east]{}
    -- (0, 2 * \drawscale) node[anchor = north west]{}
    -- (2 * \drawscale, 2 * \drawscale) node[anchor = north east]{}
    -- cycle;
    \node[
      draw = black, fill = white, anchor = south west, align = center,
      scale = \labelscale, inner sep = \labelinnersep,
      line width = \labellinewidth
    ] (Lvv) at (0.1 * \drawscale, 0.1 * \drawscale) {
      $L_{vv}$ \\ [-2mm]
      {\tiny \textit{\textbf{creuse}}} \\ [-2mm]
      {\tiny \textit{avec remplissage}}
    };
    \node[
      draw = black, fill = white, anchor = south west, align = center,
      scale = \labelscale, inner sep = \labelinnersep,
      line width = \labellinewidth
    ] (Uvv) at (0.9 * \drawscale, 1.2 * \drawscale) {
      $\scriptstyle U_{vv} = L_{vv}^T$ \\ [-2mm]
      {\tiny \textit{\textbf{creuse}}} \\ [-2mm]
      {\tiny \textit{avec remplissage}}
    }; &
    \draw[
      submatrix, pattern = sparse,
    ] (0, 0) rectangle ++(0.5 * \drawscale, 2 * \drawscale);
    \node[submatrixlabel] (Asvj) at (0.25 * \drawscale, 1 * \drawscale) {
      $A_{sv_{j}}^T$ \\ [-2mm]
      {\tiny \textit{\textbf{creuse}}}
    }; \\ [-3mm]
    \draw[
      submatrix, pattern = sparse,
    ] (0, 0) rectangle ++(2 * \drawscale, 0.5 * \drawscale);
    \node[submatrixlabel] (Asvi) at (1 * \drawscale, 0.25 * \drawscale) {
      $A_{sv_{i}}$ \\ [-2mm]
      {\tiny \textit{\textbf{creuse}}}
    }; &
    \draw[submatrix]
       (0, 0) node[anchor = south west]{}
    -- (0, 1 * \drawscale) node[anchor = north west]{}
    -- (0.25 * \drawscale, 1 * \drawscale) node[anchor = north]{}
    -- (0.25 * \drawscale, 0.75 * \drawscale) node{}
    -- (0.5  * \drawscale, 0.75 * \drawscale) node{}
    -- (0.5  * \drawscale, 0.5  * \drawscale) node{}
    -- (0.75 * \drawscale, 0.5  * \drawscale) node{}
    -- (0.75 * \drawscale, 0.25 * \drawscale) node{}
    -- (1    * \drawscale, 0.25 * \drawscale) node[anchor = north east]{}
    -- (1    * \drawscale, 0    * \drawscale) node[anchor = south east]{}
    -- cycle;
    \draw[
      submatrix, pattern = dense, pattern color = red
    ] (0, 0) rectangle ++(0.5 * \drawscale, 0.5 * \drawscale);
    \node[submatrixlabel] (S) at (0.5 * \drawscale, 0.5 * \drawscale) {
      $S_{ij}$ \\ [-2mm]
      {\tiny \textit{\textbf{dense}}}
    }; \\
  };
  \draw[
    submatrix, pattern = dense, pattern color = black
  ] (2 * \drawscale, -1.55 * \drawscale) rectangle
  ++(0.5 * \drawscale, 0.5 * \drawscale);
  \node[submatrixlabel] (X) at (2 * \drawscale, -1.05 * \drawscale) {
    $-X_{ij}$ \\ [-2mm]
    {\tiny \textit{\textbf{dense}}}
  };
  \draw[-{Stealth[length=5mm]}, line width = \submatrixlinewidth] (X) -- (S);
\end{tikzpicture}
\end{document}
